from http import HTTPStatus
from typing import Any, Optional, Union
from uuid import UUID

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...types import Response


def _get_kwargs(
    user_ctx_id: UUID,
    building_id: UUID,
    apartment_id: UUID,
    entrance_id: UUID,
    address_id: UUID,
) -> dict[str, Any]:
    _kwargs: dict[str, Any] = {
        "method": "delete",
        "url": f"/reod/v1/{user_ctx_id}/building/{building_id}/apartment/{apartment_id}/entrance/{entrance_id}/address/{address_id}",
    }

    return _kwargs


def _parse_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Optional[Any]:
    if response.status_code == 200:
        return None
    if response.status_code == 400:
        return None
    if response.status_code == 401:
        return None
    if response.status_code == 403:
        return None
    if response.status_code == 404:
        return None
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: Union[AuthenticatedClient, Client], response: httpx.Response) -> Response[Any]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    user_ctx_id: UUID,
    building_id: UUID,
    apartment_id: UUID,
    entrance_id: UUID,
    address_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
) -> Response[Any]:
    """Delete Address

     Delete an Address.

    Args:
        user_ctx_id (UUID):
        building_id (UUID):
        apartment_id (UUID):
        entrance_id (UUID):
        address_id (UUID):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Any]
    """

    kwargs = _get_kwargs(
        user_ctx_id=user_ctx_id,
        building_id=building_id,
        apartment_id=apartment_id,
        entrance_id=entrance_id,
        address_id=address_id,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


async def asyncio_detailed(
    user_ctx_id: UUID,
    building_id: UUID,
    apartment_id: UUID,
    entrance_id: UUID,
    address_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
) -> Response[Any]:
    """Delete Address

     Delete an Address.

    Args:
        user_ctx_id (UUID):
        building_id (UUID):
        apartment_id (UUID):
        entrance_id (UUID):
        address_id (UUID):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Any]
    """

    kwargs = _get_kwargs(
        user_ctx_id=user_ctx_id,
        building_id=building_id,
        apartment_id=apartment_id,
        entrance_id=entrance_id,
        address_id=address_id,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)
